diff --git a/app/views/common/_edit_habtm.erb b/app/views/common/_edit_habtm.erb
index 475d7cd..54a253f 100644
--- a/app/views/common/_edit_habtm.erb
+++ b/app/views/common/_edit_habtm.erb
@@ -1,8 +1,12 @@
-| <% for association in associations -%>
-  <%= check_box_tag(
-    "#{klass.class.to_s.downcase}[#{association.class.to_s.downcase}_ids][]",
-      association.id, klass.send(association.class.table_name).to_a.include?(association))
-    %>
-  <%= association %> |
-  <%= hidden_field_tag "#{klass.class.to_s.downcase}[#{association.class.to_s.downcase}_ids][]" %>
-<% end -%>
+<div class="box tabular">
+  <% for association in associations -%>
+    <% content_tag_for :label, association, :class=>"floating" do %>
+      <%= check_box_tag(
+        "#{klass.class.to_s.downcase}[#{association.class.to_s.downcase}_ids][]",
+          association.id, klass.send(association.class.table_name).to_a.include?(association))
+      %>
+      <%= contract association %>
+      <%= hidden_field_tag "#{klass.class.to_s.downcase}[#{association.class.to_s.downcase}_ids][]" %>
+    <% end -%>
+  <% end -%>
+</div>
diff --git a/app/views/common_parameters/_parameter.erb b/app/views/common_parameters/_parameter.erb
index 1163b06..7b6984e 100644
--- a/app/views/common_parameters/_parameter.erb
+++ b/app/views/common_parameters/_parameter.erb
@@ -6,7 +6,7 @@
     <td>
       <%= f.text_field :value, :size => 75 %>
       <%= f.hidden_field :nested %>
-      <%= link_to_remove_fields("remove", f) %>
+      <%= authorized_via_my_scope(params[:controller], params[:action]) ? link_to_remove_fields("remove", f) : "" %>
     </td>
   </tr>
 </table>
diff --git a/app/views/common_parameters/_parameters.erb b/app/views/common_parameters/_parameters.erb
index 8161f2a..bc5d1b0 100644
--- a/app/views/common_parameters/_parameters.erb
+++ b/app/views/common_parameters/_parameters.erb
@@ -2,7 +2,7 @@
   <% f.fields_for type do |builder| -%>
     <%= render "common_parameters/parameter", :f => builder %>
   <% end -%>
-  <p><%= link_to_add_fields "Add a parameter", f, type, "common_parameters/parameter" %></p>
+  <p><%= authorized_via_my_scope(params[:controller], params[:action]) ? link_to_add_fields("Add a parameter", f, type, "common_parameters/parameter") : "Add a parameter" %></p>
 <% end -%>
 
 
diff --git a/app/views/common_parameters/index.html.erb b/app/views/common_parameters/index.html.erb
index fac3ed0..bfb3c57 100644
--- a/app/views/common_parameters/index.html.erb
+++ b/app/views/common_parameters/index.html.erb
@@ -7,11 +7,11 @@
     <th></th>
   </tr>
   <% for common_parameter in @common_parameters %>
-    <tr>
-      <td><%= link_to h(common_parameter), edit_common_parameter_path(common_parameter)%></td>
+    <tr class="<%= cycle("even", "odd") -%>" >
+      <td><%= link_to_if_authorized h(common_parameter), hash_for_edit_common_parameter_path(:id => common_parameter.id)%></td>
       <td><%=h common_parameter.value %></td>
       <td align=""right>
-        <%= link_to "Destroy", common_parameter, :confirm => "Delete #{common_parameter.name}?", :method => :delete %>
+        <%= display_link_if_authorized "Destroy", hash_for_common_parameter_path(:id => common_parameter, :auth_action => :destroy), :confirm => "Delete #{common_parameter.name}?", :method => :delete %>
       </td>
     </tr>
   <% end %>
@@ -19,4 +19,4 @@
 <%= page_entries_info @common_parameters %>
 <%= will_paginate     @common_parameters %>
 
-<p><%= link_to "New Common Parameter", new_common_parameter_path %></p>
+<p><%= display_link_if_authorized "New Common Parameter", hash_for_new_common_parameter_path %></p>
diff --git a/app/views/domains/index.html.erb b/app/views/domains/index.html.erb
index c706e98..337b0c2 100644
--- a/app/views/domains/index.html.erb
+++ b/app/views/domains/index.html.erb
@@ -8,13 +8,13 @@
   </tr>
   <% for domain in @domains %>
     <tr class="<%= cycle("even", "odd") -%>">
-      <td><%= link_to h(domain.fullname.empty? ? domain.name : domain.fullname), edit_domain_path(domain)%></td>
+      <td><%= link_to_if_authorized h(domain.fullname.empty? ? domain.name : domain.fullname), hash_for_edit_domain_path(:id => domain.id)%></td>
       <td><%= domain.hosts.size %>
-      <td align="right"> <%= link_to "Destroy", domain, :confirm => 'Are you sure?', :method => :delete %></td>
+      <td align="right"> <%= display_link_if_authorized "Destroy", hash_for_domain_path(:id => domain, :auth_action => :destroy), :confirm => "Delete #{domain.name}?", :method => :delete %></td>
     </tr>
   <% end %>
 </table>
 <%= page_entries_info @domains %>
 <%= will_paginate     @domains %>
 
-<p><%= link_to "New Domain", new_domain_path %></p>
+<p><%= display_link_if_authorized "New Domain", hash_for_new_domain_path%></p>
diff --git a/app/views/environments/index.html.erb b/app/views/environments/index.html.erb
index e09bc09..f22d7cd 100644
--- a/app/views/environments/index.html.erb
+++ b/app/views/environments/index.html.erb
@@ -8,12 +8,12 @@
   <% for environment in @environments %>
     <tr class="<%= cycle("even", "odd") -%>">
       <td>
-        <%= link_to h(environment.name), edit_environment_path(environment) %>
+        <%= link_to_if_authorized h(environment.name), hash_for_edit_environment_path(:id=> environment.id) %>
       </td>
       <td style="float:right;">
         <%= link_to "Hosts",   hosts_path         + "?search[environment_id_equals]=#{environment.id}"%>
         <%= link_to "classes", puppetclasses_path + "?search[environments_id_equals]=#{environment.id}"%>
-        <%= link_to "Destroy", environment, :confirm => "Delete environment '#{environment.name}'?", :method => :delete %>
+        <%= display_link_if_authorized "Destroy", hash_for_environment_path(:id => environment, :auth_action => :destroy), :confirm => "Delete #{environment.name}?", :method => :delete %>
       </td>
     </tr>
   <% end %>
@@ -22,6 +22,6 @@
 <%= page_entries_info @environments %>
 <%= will_paginate @environmentsS %>
 
-<p><%= link_to "New Environment", new_environment_path %>
-   <%= link_to "Import all classes and environments",  import_environments_environments_path %>
+<p><%= display_link_if_authorized "New Environment", hash_for_new_environment_path %> 
+   <%= display_link_if_authorized "Import all classes and environments",  hash_for_import_environments_environments_path, :action => "import_environments" %>
 </p>
diff --git a/app/views/home/_menu.erb b/app/views/home/_menu.erb
index 2622866..d5447d0 100644
--- a/app/views/home/_menu.erb
+++ b/app/views/home/_menu.erb
@@ -1,18 +1,20 @@
 <div id="menu">
-  <table>
+  <table width="100%">
     <tr>
       <td style="width: 100%;">
         <ul>
-          <li> <%= link_to "Dashboard",  dashboard_path   %> </li>
-          <li> <%= link_to "Hosts",      hosts_path       %> </li>
-          <li> <%= link_to "Reports",    reports_path     %> </li>
-          <li> <%= link_to "Facts",      fact_values_path %> </li>
-          <li> <%= link_to "Audit Log",  audits_path      %> </li>
-          <li> <%= link_to "Statistics", statistics_path  %> </li>
+          <li> <%= link_to_if_authorized "Dashboard",  hash_for_dashboard_path %> </li>
+          <li> <%= link_to_if_authorized "Hosts",      hash_for_hosts_path %> </li>
+          <li> <%= link_to_if_authorized "Reports",    hash_for_reports_path %> </li>
+          <li> <%= link_to_if_authorized "Facts",      hash_for_fact_values_path %> </li>
+          <li> <%= link_to_if_authorized "Audit Log",  hash_for_audits_path %> </li>
+          <li> <%= link_to_if_authorized "Statistics", hash_for_statistics_path %> </li>
         </ul>
       </td>
       <td>
+        <% if User.current.admin? or User.current.allowed_to?(:access_settings) -%>
         <%= render "home/settings" -%>
+        <% end -%>
       </td>
     </tr>
   </table>
diff --git a/app/views/home/_settings.html.erb b/app/views/home/_settings.html.erb
index 32bcb77..d4e4b62 100644
--- a/app/views/home/_settings.html.erb
+++ b/app/views/home/_settings.html.erb
@@ -15,6 +15,9 @@
     ['Puppet Classes',      puppetclasses_url],
   ]
   choices += [
+    ['Roles',               roles_url]
+  ] if SETTINGS[:login] and User.current.admin?
+  choices += [
     ['Users',               users_url],
     ['Usergroups',          usergroups_url]
   ] if  SETTINGS[:login]
diff --git a/app/views/home/_topbar.rhtml b/app/views/home/_topbar.rhtml
index 56d36ff..59a7f8e 100644
--- a/app/views/home/_topbar.rhtml
+++ b/app/views/home/_topbar.rhtml
@@ -1,5 +1,3 @@
-<% if SETTINGS[:login] and SETTINGS[:login] == true -%>
-  <%= link_to "Sign Out #{@user.login}", logout_users_path if @user %>
-<% end -%>
-<%= link_to           'Wiki',      "http://theforeman.org/wiki/foreman" %>
-<%= link_to           'Support',   "http://theforeman.org/projects/foreman/boards" %>
+<%= link_to("Sign Out #{User.current.login}", logout_users_path) if SETTINGS[:login] and SETTINGS[:login] == true and  User.current %>
+<%= link_to 'Wiki',    "http://theforeman.org/wiki/foreman" %>
+<%= link_to 'Support', "http://theforeman.org/projects/foreman/boards" %>
diff --git a/app/views/hostgroups/index.html.erb b/app/views/hostgroups/index.html.erb
index 4d508cb..eff581a 100644
--- a/app/views/hostgroups/index.html.erb
+++ b/app/views/hostgroups/index.html.erb
@@ -7,13 +7,13 @@
   </tr>
   <% for hostgroup in @hostgroups %>
     <tr class="<%= cycle("even", "odd") -%>">
-      <td><%=link_to h(hostgroup.name), edit_hostgroup_path(hostgroup) %></td>
+      <td><%=link_to_if_authorized h(hostgroup.name), hash_for_edit_hostgroup_path(:id => hostgroup) %></td>
       <td align="right">
-        <%= link_to "Destroy", hostgroup, :confirm => 'Are you sure?', :method => :delete %>
+        <%= display_link_if_authorized "Destroy", hash_for_hostgroup_path(:id => hostgroup, :auth_action => :destroy), :confirm => 'Are you sure?', :method => :delete %>
       </td>
     </tr>
   <% end %>
 </table>
 <%= page_entries_info @hostgroups %>
 <%= will_paginate     @hostgroups %>
-<p><%= link_to "New Hostgroup", new_hostgroup_path %></p>
+<p><%= display_link_if_authorized "New Hostgroup", hash_for_new_hostgroup_path %></p>
diff --git a/app/views/hosts/_minilist.html.erb b/app/views/hosts/_minilist.html.erb
index fc748cf..1d4d618 100644
--- a/app/views/hosts/_minilist.html.erb
+++ b/app/views/hosts/_minilist.html.erb
@@ -1,4 +1,5 @@
 <% if hosts.size > 0 -%>
+  <% allow_multiple = authorized_for(:hosts, :edit) or authorized_for(:hosts, :destroy) -%>
   <% form_tag(multiple_actions_hosts_path,:method => "get", :id => "host_select_form") do %>
     <% title header ||= "" %>
     <table class="list">
@@ -14,7 +15,9 @@
       <% hosts.each do |host| -%>
         <tr class="<%= cycle("even", "odd") -%>">
           <td>
-            <%= check_box_tag "host_ids[]", host.id, selected?(host), :id => "host_ids_#{host.id}", :class => 'host_select_boxes', :onclick => 'insertHostVal(this)' -%>
+            <% if allow_multiple -%>
+              <%= check_box_tag "host_ids[]", host.id, selected?(host), :id => "host_ids_#{host.id}", :class => 'host_select_boxes', :onclick => 'insertHostVal(this)' -%>
+            <% end -%>
             <%=name_column(host) %>
           </td>
           <td><%=h host.try(:os) %></td>
@@ -23,15 +26,15 @@
           <td><%=h host.try(:hostgroup) %></td>
           <td><%=last_report_column(host) %></td>
           <td>
-            <%= link_to 'Edit', edit_host_url(host)  %>
-            <%= link_to 'Clone', clone_host_url(host)  %>
-            <%= link_to 'Destroy', host, :confirm => "Delete #{host.name}?", :method => :delete %>
+            <%= display_link_if_authorized 'Edit',    hash_for_edit_host_path(:id => host) %>
+            <%= display_link_if_authorized 'Clone',   hash_for_clone_host_path(:id => host)  %>
+            <%= display_link_if_authorized 'Destroy', hash_for_host_path(:id => host, :auth_action => :destroy), :confirm => "Delete #{host.name}?", :method => :delete, :action => :destroy %>
           </td>
         </tr>
       <% end -%>
     </table>
     <div>
-      <%= submit_tag("Edit Multiple Hosts", :title => "Mass assign values to many hosts") %>
+      <%= submit_tag("Edit Multiple Hosts", :title => "Mass assign values to many hosts") if allow_multiple %><br />
     </div>
   <% end -%>
 <% end -%>
diff --git a/app/views/hosts/index.html.erb b/app/views/hosts/index.html.erb
index ec7c95b..62eaa93 100644
--- a/app/views/hosts/index.html.erb
+++ b/app/views/hosts/index.html.erb
@@ -1,7 +1,9 @@
 <%= javascript "host_checkbox" %>
 <%= render 'minilist', :hosts => @hosts, :header => @title || "Hosts"  %>
 <span class="title_action">
-  <%= link_to "New Host", new_host_path %> |
-  <%= link_to_function "Toggle All", "toggleCheck()" %> |
+  <%= display_link_if_authorized "New Host", hash_for_new_host_path %> |
+  <% if authorized_for(:hosts, :edit) or authorized_for(:hosts, :destroy) -%>
+  <%= link_to_function "Toggle All", "toggleCheck()" %>
   <%= link_to "Reset Selection", reset_multiple_hosts_path %>
+  <% end -%>
 </span>
diff --git a/app/views/hosts/show.html.erb b/app/views/hosts/show.html.erb
index 0a01942..4136588 100644
--- a/app/views/hosts/show.html.erb
+++ b/app/views/hosts/show.html.erb
@@ -1,24 +1,20 @@
 <% gcharts_script %>
 <% title @host.to_label %>
 <span class="title_action">
-  <%= link_to "Edit", edit_host_path(@host), :title => "Edit your host" %> |
-  <%= link_to "Facts", facts_host_path, :title => "Browse host facts" %> |
-  <%= link_to "Reports", reports_host_path(@host), :title => "Browse host reports" %> |
-  <%= link_to "YAML", externalNodes_host_path(@host), :title => "Puppet external nodes YAML dump" %> |
+  <%= link_to_if_authorized "Edit",    hash_for_edit_host_path(:id => @host),                                        :title => "Edit your host" %> |
+  <%= link_to_if_authorized "Facts",   hash_for_fact_values_path(:id => @host, "search[host_id_eq]" => @host.id),    :title => "Browse host facts" %> |
+  <%= link_to_if_authorized "Reports", hash_for_reports_host_path(:id => @host),                                     :title => "Browse host reports" %> |
+  <%= link_to_if_authorized "YAML",    hash_for_externalNodes_host_path(:id => @host),                               :title => "Puppet external nodes YAML dump" %> |
   <% unless @host.build -%>
-    <span title="prepare this host for build; requires unattended mode">
-      <%= link_to_if @host.can_be_build?, "Build", setBuild_host_path(@host) %>
-    </span>
+    <%= link_to_if_authorized "Build",        hash_for_setBuild_host_path(:id => @host).merge(:auth_action => :edit, :enable_link => @host.can_be_build?),      :title => "Enable rebuild on next host boot" %>
   <% else -%>
-    <%= link_to "Cancel Build", cancelBuild_host_path(@host), :title => "cancel build request for this host" %>
+    <%= link_to_if_authorized "Cancel Build", hash_for_cancelBuild_host_path(:id => @host).merge(:auth_action => :edit, :enable_link => !@host.can_be_build?),  :title => "Cancel build request for this host" %>
   <% end -%> |
-  <span title="trigger a puppetrun on a node; requires that Puppet run is enabled">
-    <%= link_to_if SETTINGS[:puppetrun], "Run Puppet", puppetrun_host_path(@host) %>
-  </span> |
+    <%= link_to_if_authorized "Run puppet", hash_for_puppetrun_host_path(:id => @host).merge(:auth_action => :edit, :enable_link => SETTINGS[:puppetrun]),  :title => "Trigger a puppetrun on a node; requires that puppet run is enabled" %> |
   <span title="Show all host puppet classes, requires storeconfigs">
     <%= link_to_if @host.resources.count > 0, "All Puppet Classes", storeconfig_klasses_host_path(@host) %>
   </span> |
-  <%= link_to "Delete", host_path(@host), :confirm => 'Are you sure?', :method => :delete%>
+  <%= link_to_if_authorized "Delete", hash_for_host_path(:id => @host, :auth_action => :destroy), :confirm => 'Are you sure?', :method => :delete%>
 </span>
 
 <div id="host_overview">
diff --git a/app/views/layouts/standard.rhtml b/app/views/layouts/standard.rhtml
index 64b833c..37dadb3 100644
--- a/app/views/layouts/standard.rhtml
+++ b/app/views/layouts/standard.rhtml
@@ -12,7 +12,7 @@
       <div class="title" style="text-align:center;">
         The Foreman
       </div>
-      <%= render "home/menu" -%>
+      <%= render("home/menu") unless session[:user].nil? -%>
     </div>
     <%= render "common/searchbar" rescue "<!-- The search facility is not available in this controllers -->" unless params[:action] == 'show' %>
     <%= content_tag('div', flash[:foreman_error],  :class => 'flash error')  if flash[:foreman_error] -%>
diff --git a/app/views/lookup_keys/_fields.html.erb b/app/views/lookup_keys/_fields.html.erb
index 8375802..03d2db8 100644
--- a/app/views/lookup_keys/_fields.html.erb
+++ b/app/views/lookup_keys/_fields.html.erb
@@ -6,4 +6,4 @@
 <% f.fields_for :lookup_values do |builder| -%>
   <%= render 'value', :f => builder %>
 <% end -%>
-<p><%= link_to_add_fields "Add a value", f, :lookup_values, "value" %></p>
+<p><%= authorized_for(params[:controller], params[:action]) ? link_to_add_fields("Add a value", f, :lookup_values, "value") : "Add a value" %></p>
diff --git a/app/views/lookup_keys/_value.html.erb b/app/views/lookup_keys/_value.html.erb
index 0210378..1c0b2db 100644
--- a/app/views/lookup_keys/_value.html.erb
+++ b/app/views/lookup_keys/_value.html.erb
@@ -3,6 +3,6 @@
 <%= f.text_field :value %>
 <%= f.label :priority, "Priority" %>
 <%= f.text_field :priority %>
-<%= link_to_remove_fields("remove", f) %>
+<%= link_to_remove_fields("remove", f) if authorized_for(params[:controller], params[:action]) %>
 </p>
 
diff --git a/app/views/lookup_keys/index.html.erb b/app/views/lookup_keys/index.html.erb
index 5c25042..fd6495a 100644
--- a/app/views/lookup_keys/index.html.erb
+++ b/app/views/lookup_keys/index.html.erb
@@ -9,13 +9,13 @@
 
 <% @lookup_key.each do |lookup_key| %>
   <tr class="<%= cycle("even", "odd") -%>">
-    <td><%= link_to h(lookup_key.key), edit_lookup_key_path(lookup_key) %></td>
+    <td><%= link_to_if_authorized h(lookup_key.key), hash_for_edit_lookup_key_path(:id => lookup_key) %></td>
     <td><%=h lookup_key.lookup_values.count %></td>
-    <td><%= link_to 'Destroy', lookup_key, :confirm => 'Are you sure?', :method => :delete %></td>
+    <td><%= display_link_if_authorized 'Destroy', hash_for_lookup_key_path(:id => lookup_key, :auth_action => :destroy), :confirm => "Delete #{lookup_key.key}?", :method => :delete %></td>
   </tr>
 <% end %>
 </table>
 
 <br />
 
-<%= link_to 'New Variable', new_lookup_key_path %>
+<%= display_link_if_authorized 'New Variable', hash_for_new_lookup_key_path %>
diff --git a/app/views/medias/_form.html.erb b/app/views/medias/_form.html.erb
index 4b33b72..f52d205 100644
--- a/app/views/medias/_form.html.erb
+++ b/app/views/medias/_form.html.erb
@@ -15,8 +15,9 @@
   </small>
   <p>
   <%= f.label :operatingsystems %><br />
-  <%= edit_habtm @media, Operatingsystem %>
+  <%= authorized_edit_habtm @media, Operatingsystem %>
   </p>
+   <br/>
   <% unless @media.new_record? -%>
     <p>Currently used by <%= @media.hosts.count %> hosts</p>
   <% end -%>
diff --git a/app/views/medias/index.html.erb b/app/views/medias/index.html.erb
index ba6863e..a3a93e4 100644
--- a/app/views/medias/index.html.erb
+++ b/app/views/medias/index.html.erb
@@ -9,15 +9,15 @@
   </tr>
   <% for media in @medias %>
     <tr class="<%= cycle("even", "odd") -%>">
-      <td><%= link_to h(media), edit_media_path(media) %></td>
+      <td><%= link_to_if_authorized h(media), hash_for_edit_media_path(:id => media.id) %></td>
       <td><%=h media.path %></td>
       <td><%=h media.operatingsystems.to_sentence %></td>
       <td align="right">
-        <%= link_to "Destroy", media, :confirm => "Delete #{media.name}?", :method => :delete %>
+        <%= display_link_if_authorized "Destroy", hash_for_media_path(:id => media, :auth_action => :destroy), :confirm => "Delete #{media.name}?", :method => :delete %>
       </td>
     </tr>
   <% end %>
 </table>
 <%= page_entries_info @medias %>
 <%= will_paginate     @medias %>
-<p><%= link_to "New Media", new_media_path %></p>
+<p><%= display_link_if_authorized "New Media", hash_for_new_media_path %></p>
diff --git a/app/views/models/index.html.erb b/app/views/models/index.html.erb
index 386dda0..3e204d6 100644
--- a/app/views/models/index.html.erb
+++ b/app/views/models/index.html.erb
@@ -8,10 +8,10 @@
   </tr>
   <% for model in @models %>
     <tr class="<%= cycle("even", "odd") -%>">
-      <td><%=link_to h(model.name), edit_model_path(model)%></td>
+      <td><%=link_to_if_authorized h(model.name), hash_for_edit_model_path(:id => model)%></td>
       <td><%= model.hosts.count %></td>
       <td align="right">
-        <%= link_to "Destroy", model, :confirm => "Delete #{model.name}?", :method => :delete %>
+        <%= display_link_if_authorized "Destroy", hash_for_model_path(:id => model, :auth_action => :destroy), :confirm => "Delete #{model.name}?", :method => :delete %>
       </td>
     </tr>
   <% end %>
@@ -19,4 +19,4 @@
 <%= page_entries_info @models %>
 <%= will_paginate     @models %>
 
-<p><%= link_to "New Model", new_model_path %></p>
+<p><%= display_link_if_authorized "New Model", hash_for_new_model_path %></p>
diff --git a/app/views/operatingsystems/_form.html.erb b/app/views/operatingsystems/_form.html.erb
index c3f6df8..69804e2 100644
--- a/app/views/operatingsystems/_form.html.erb
+++ b/app/views/operatingsystems/_form.html.erb
@@ -20,17 +20,17 @@
   </p>
   <p>
   <% field_set_tag("Architecture") do %>
-    <%= edit_habtm @operatingsystem, Architecture %>
+    <%= authorized_edit_habtm @operatingsystem, Architecture %>
   <% end -%>
   </p>
   <p>
   <% field_set_tag("Partition tables") do %>
-    <%= edit_habtm @operatingsystem, Ptable %>
+    <%= authorized_edit_habtm @operatingsystem, Ptable %>
   <% end -%>
   </p>
   <p>
   <% field_set_tag("Installation Medias") do %>
-    <%= edit_habtm @operatingsystem, Media %>
+    <%= authorized_edit_habtm @operatingsystem, Media %>
   <% end -%>
   </p>
 
diff --git a/app/views/operatingsystems/index.html.erb b/app/views/operatingsystems/index.html.erb
index 5e62ca8..93c9ba9 100644
--- a/app/views/operatingsystems/index.html.erb
+++ b/app/views/operatingsystems/index.html.erb
@@ -8,10 +8,10 @@
   </tr>
   <% for operatingsystem in @operatingsystems %>
     <tr class="<%= cycle("even", "odd") -%>">
-      <td><%= link_to h(operatingsystem.to_label), edit_operatingsystem_path(operatingsystem) %></td>
+      <td><%= link_to_if_authorized h(operatingsystem.to_label), hash_for_edit_operatingsystem_path(:id => operatingsystem.id) %></td>
       <td><%= h operatingsystem.family %></td>
       <td align="right">
-        <%= link_to "Destroy", operatingsystem_path(operatingsystem), :confirm => "Delete #{operatingsystem.fullname}?", :method => :delete %>
+        <%= display_link_if_authorized "Destroy", hash_for_operatingsystem_path(:id => operatingsystem, :auth_action => :destroy), :confirm => "Delete #{operatingsystem.fullname}?", :action => :destroy %>
       </td>
     </tr>
   <% end %>
@@ -20,4 +20,4 @@
 <%= page_entries_info @operatingsystems, :entry_name => "operating system" %>
 <%= will_paginate @operatingsystems %>
 
-<p><%= link_to "New Operatingsystem", new_operatingsystem_path %></p>
+<p><%= display_link_if_authorized "New Operatingsystem", hash_for_new_operatingsystem_path %></p>
diff --git a/app/views/ptables/_form.html.erb b/app/views/ptables/_form.html.erb
index 9ac8c34..f9253d8 100644
--- a/app/views/ptables/_form.html.erb
+++ b/app/views/ptables/_form.html.erb
@@ -9,7 +9,8 @@
   <%= f.text_area :layout, :size => "80x20" %>
   </p>
   <p>
-  <%= edit_habtm @ptable, Operatingsystem %>
+  <%= authorized_edit_habtm @ptable, Operatingsystem %>
   </p>
+  <br/>
   <p><%= f.submit "Submit" %></p>
 <% end %>
diff --git a/app/views/ptables/index.html.erb b/app/views/ptables/index.html.erb
index dc8d313..4808a09 100644
--- a/app/views/ptables/index.html.erb
+++ b/app/views/ptables/index.html.erb
@@ -8,10 +8,10 @@
   </tr>
   <% for ptable in @ptables %>
     <tr class="<%= cycle("even", "odd") -%>">
-      <td><%=link_to h(ptable.name), edit_ptable_path(ptable) %></td>
+      <td><%=link_to_if_authorized h(ptable.name), hash_for_edit_ptable_path(:id => ptable.id) %></td>
       <td><%=h ptable.operatingsystems.to_sentence %></td>
       <td align="right">
-        <%= link_to "Destroy", ptable, :confirm => "Delete #{ptable.name}?", :method => :delete %>
+        <%= display_link_if_authorized "Destroy", hash_for_ptable_path(:id => ptable, :auth_action => :destroy), :confirm => "Delete #{ptable.name}?", :method => :delete %>
       </td>
     </tr>
   <% end %>
@@ -19,4 +19,4 @@
 <%= page_entries_info @ptables %>
 <%= will_paginate     @ptables %>
 
-<p><%= link_to "New Partition table layout", new_ptable_path %></p>
+<p><%= display_link_if_authorized "New Partition table layout", hash_for_new_ptable_path %></p>
diff --git a/app/views/puppetclasses/_form.html.erb b/app/views/puppetclasses/_form.html.erb
index d3604d4..12494d4 100644
--- a/app/views/puppetclasses/_form.html.erb
+++ b/app/views/puppetclasses/_form.html.erb
@@ -6,17 +6,17 @@
   </p>
   <p>
   <% field_set_tag("Operating Systems") do %>
-    <%= edit_habtm @puppetclass, Operatingsystem %>
+    <%= authorized_edit_habtm @puppetclass, Operatingsystem %>
   <% end -%>
   </p>
   <p>
   <% field_set_tag("Puppet Environments") do %>
-    <%= edit_habtm @puppetclass, Environment %>
+    <%= authorized_edit_habtm @puppetclass, Environment %>
   <% end -%>
   </p>
   <% field_set_tag("Class Groups") do %>
     <p>
-    <%= edit_habtm @puppetclass, Hostgroup %>
+    <%= authorized_edit_habtm @puppetclass, Hostgroup %>
     </p>
   <% end -%>
   <% unless @puppetclass.new_record? -%>
diff --git a/app/views/puppetclasses/index.html.erb b/app/views/puppetclasses/index.html.erb
index b8b3e2b..9496919 100644
--- a/app/views/puppetclasses/index.html.erb
+++ b/app/views/puppetclasses/index.html.erb
@@ -9,16 +9,16 @@
   </tr>
   <% for puppetclass in @puppetclasses %>
     <tr class="<%= cycle("even", "odd") -%>">
-      <td><%=link_to h(puppetclass.name), edit_puppetclass_path(puppetclass) %></td>
+      <td><%=link_to_if_authorized h(puppetclass.name), hash_for_edit_puppetclass_path(:id => puppetclass.id) %></td>
       <td><%=h puppetclass.operatingsystems.to_sentence %></td>
       <td>
         <% for environment in puppetclass.environments -%>
           <%= link_to h(environment), "#", :onclick => rdoc_classes_path(environment, puppetclass.name) %>
-				<% end %>
-			</td>
+        <% end %>
+      </td>
       <td><%=h puppetclass.hostgroups.to_sentence %></td>
       <td align="right">
-        <%= link_to "Destroy", puppetclass, :confirm => "Delete #{puppetclass.name}?", :method => :delete %>
+        <%= display_link_if_authorized "Destroy", hash_for_puppetclass_path(:id => puppetclass, :auth_action => :destroy), :confirm => "Delete #{puppetclass.name}?", :method => :delete %>
       </td>
     </tr>
   <% end %>
@@ -27,7 +27,7 @@
 <%= page_entries_info @puppetclasses %>
 <%= will_paginate @puppetclasses %>
 <span class="title_action">
-  <%= link_to "New Puppetclass", new_puppetclass_path %> |
-  <%= link_to "Import new puppet classes and environments", import_environments_puppetclasses_path %>
+  <%= display_link_if_authorized "New Puppetclass", hash_for_new_puppetclass_path %> |
+  <%= display_link_if_authorized "Import new puppet classes and environments", hash_for_import_environments_puppetclasses_path %>
 </span>
 
diff --git a/app/views/reports/_list.html.erb b/app/views/reports/_list.html.erb
index 8448eeb..5919918 100644
--- a/app/views/reports/_list.html.erb
+++ b/app/views/reports/_list.html.erb
@@ -28,7 +28,7 @@
       <td><%= h report.runtime %></td>
       <td align="right">
         <%= link_to "Details", report %>
-        <%= link_to "Destroy", report, :confirm => "Delete report for #{report.host.name}?", :method => :delete %>
+        <%= display_link_if_authorized "Destroy", hash_for_report_path(:id => report.id, :auth_action => :destroy), :confirm => "Delete report for #{report.host.name}?", :method => :delete %>
       </td>
     </tr>
   <% end %>
diff --git a/app/views/reports/show.rhtml b/app/views/reports/show.rhtml
index ae21806..ec613c5 100644
--- a/app/views/reports/show.rhtml
+++ b/app/views/reports/show.rhtml
@@ -37,6 +37,6 @@ Reported at <%= @report.reported_at.getlocal %>, which is <b><%= time_ago_in_wor
 </div>
 
 <%= link_to 'Back', :back %> |
-<%= link_to 'Delete', report_path(@report, :method => :delete) -%> |
+<%= display_link_if_authorized 'Delete', hash_for_report_path(:id => @report, :auth_action => :destroy), :method => :delete -%> |
 <%= link_to "Host details", @report.host %> |
 <%= link_to "Other reports for this hosts", reports_host_path(@report.host) %>
diff --git a/app/views/roles/_form.rhtml b/app/views/roles/_form.rhtml
new file mode 100644
index 0000000..b7d88d1
--- /dev/null
+++ b/app/views/roles/_form.rhtml
@@ -0,0 +1,27 @@
+<% form_for @role do |f| %>
+  <%= error_messages_for 'role' %>
+
+  <% if @role.builtin? %>
+    <h2><b>Name</b> <i><%= @role.name -%></i></h2>
+  <% else %>
+    <%= f.text_field :name, :label => "Name", :style => "margin-left:1px;", :required => true %>
+  <% end %>
+
+  <h3>Permissions</h3>
+  <div class="box" id="permissions">
+    <% perms_by_block = @permissions.group_by {|p| p.security_block.to_s} %>
+    <% perms_by_block.keys.sort.each do |block| %>
+      <fieldset><legend><%=  block.humanize %></legend>
+        <% perms_by_block[block].each do |permission| %>
+          <label class="floating">
+            <%= check_box_tag 'role[permissions][]', permission.name, (@role.permissions.include? permission.name) %>
+            <%= permission.name.to_s.humanize %>
+          </label>
+        <% end %>
+      </fieldset>
+    <% end %>
+    <br /><%= check_all_links 'permissions' %>
+    <%= hidden_field_tag 'role[permissions][]', '' %>
+  </div>
+  <%= submit_tag "Submit" %>
+<% end %>
diff --git a/app/views/roles/edit.rhtml b/app/views/roles/edit.rhtml
new file mode 100644
index 0000000..c84de0a
--- /dev/null
+++ b/app/views/roles/edit.rhtml
@@ -0,0 +1,4 @@
+<%= javascript "redmine-application" %>
+<% title "Edit roles" %>
+
+<%= render 'form' %>
diff --git a/app/views/roles/index.html.erb b/app/views/roles/index.html.erb
new file mode 100644
index 0000000..93615d9
--- /dev/null
+++ b/app/views/roles/index.html.erb
@@ -0,0 +1,32 @@
+<%= javascript "redmine-application" %>
+<h2>Roles</h2>
+
+<table class="list">
+  <thead>
+    <tr>
+      <th>Role</th>
+      <th></th>
+    </tr>
+  </thead>
+  <tbody>
+    <% for role in @roles %>
+      <tr class="<%= cycle("odd", "even") %>">
+        <td>
+          <%= content_tag(role.builtin? ? 'em' : 'span', link_to_if_authorized(role.name, :action => 'edit', :id => role)) %>
+        </td>
+        <td class="buttons">
+          <%= display_link_if_authorized("Delete", hash_for_role_path(:id => role, :auth_action => :destroy),
+                                    :method => :delete,
+                                    :confirm => "Delete #{role.name}?",
+                                    :class => 'icon icon-del') unless role.builtin?
+          %>
+        </td>
+      </tr>
+    <% end %>
+  </tbody>
+</table>
+<%= page_entries_info @roles %>
+<%= will_paginate     @roles %>
+<p><%= link_to "New role", {:action => 'new'} %>
+
+<%= link_to_if_authorized "Permissions report", :action => 'report' %></p>
diff --git a/app/views/roles/new.rhtml b/app/views/roles/new.rhtml
new file mode 100644
index 0000000..5c32d07
--- /dev/null
+++ b/app/views/roles/new.rhtml
@@ -0,0 +1,4 @@
+<%= javascript "redmine-application" %>
+<% title "New Role" %>
+
+<%= render 'form' %>
